/*
 * Primer server koda koji koristi
 * funkcije sendstring i receivestring
 * deklarisane u protocol.h da bi 
 * razmenjivao poruke sa klijentom.
 * 
 * Autor: Ikac, ikac.ikax@gmail.com
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "protocol.h"

void error(const char *msg)
{
	perror(msg);
	exit(1);
}

int main(int argc, char **argv)
{
	int sockfd, newsockfd, portno;
	socklen_t clilen;

	struct sockaddr_in serv_addr, cli_addr;
	int n;

	if (argc < 2) {
		fprintf(stderr, "ERROR, no port provided\n");
		exit(1);
	}

	sockfd = socket(AF_INET, SOCK_STREAM, 0);

	bzero((char *)&serv_addr, sizeof(serv_addr));

	portno = atoi(argv[1]);

	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = INADDR_ANY;
	serv_addr.sin_port = htons(portno);

	if (bind(sockfd, (struct sockaddr *)&serv_addr, sizeof(serv_addr)) < 0)
		error("ERROR on binding");

	listen(sockfd, 5);

	clilen = sizeof(cli_addr);

  char * buffer;

	while (1) {
		newsockfd =
		    accept(sockfd, (struct sockaddr *)&cli_addr, &clilen);

		if (newsockfd < 0)
			error("ERROR on accept");

		n = receivestring(newsockfd, &buffer);

		if (n < 0)
			error("ERROR reading from socket");

		printf("Here is the message: %s\n", buffer);

		n = sendstring(newsockfd, buffer);
    
		if (n < 0)
			error("ERROR writing to socket");

		close(newsockfd);
	}

	close(sockfd);
	return 0;
}
